'use strict';

function parseQueryString(url) {
    if (typeof url !== 'string') {
        return {};
    }

    var queryString = url.substring(url.indexOf('?') + 1);
    var queries = queryString.split('&');
    var params = {};

    for (var i = 0, l = queries.length; i < l; i++) {
        if (!queries[i]) {
            continue;
        }
        var tmp = queries[i].split('=');
        if (!tmp[1]) {
            params[tmp[0]] = '';
            continue;
        }
        try {
            params[tmp[0]] = decodeURIComponent(tmp[1]);
        } catch (err) {
            params[tmp[0]] = tmp[1];
        }
    }

    return params;
}

var IS_SWIPE = true;
var $queryString = parseQueryString(window.location.href);
var $city = $queryString.app_city;
var $uuid = $queryString.uuid;
var PROFILE_URL = 'https://m.renrenche.com/api/user/profile';
var QUALITY_CAR_URL = 'https://m.renrenche.com/api/user/quality_car/list';

var pageHide = function pageHide(index) {
    if (index > 4) {
        $('.js-guide-' + (index - 1)).hide();
    } else {
        $('.js-guide-' + index).show();
        $('.js-guide-' + (index - 1)).addClass('rotateCard');
        setTimeout(function () {
            $('.js-guide-' + (index - 1)).hide();
        }, 500);
    }
};

var currentPage = function currentPage(index) {
    pageHide(index);
    $('.js-guide-container').height($(window).height());
    // 样式展示转换
    $('.js-page').removeClass('active');
    $('.js-page' + index).addClass('active');

    if (navigator.userAgent.indexOf("iOS") > -1) {
        window.webkit.messageHandlers.logging.postMessage({
            eventId: '新用户引导页面展现',
            eventContent: {
                index: index
            }
        });
    } else if (window.JavaBridge) {
        window.JavaBridge.callAppLogging('新用户引导页面展现', JSON.stringify({
            'index': index
        }));
    }
};

var part5 = function part5() {
    currentPage(5);
    $('.js-huadong').show();
    $('.js-guide-5').show();
    var guideContent5 = $('.js-guide-content-5');
    var tuijian = guideContent5.find('.js-tuijian');
    [2, 1, 0].forEach(function (elem) {
        tuijian.eq(elem).addClass('tuijian' + (elem + 1));
    });
    var handler = function handler(swipe) {
        if (IS_SWIPE) {
            IS_SWIPE = false;
            var $li = guideContent5.find('li');
            var $li0 = $li.eq(0);
            var $brand = $li0.data('brand');
            var $series = $li0.data('series');
            var $liShowIndex = $li0.data('show');

            if (swipe.includes('right')) {
                $li0.addClass('activeRotateCardLeft');
            } else if (swipe.includes('left')) {
                $li0.addClass('activeRotateCardRight');
            }

            if (navigator.userAgent.indexOf("iOS") > -1) {
                window.webkit.messageHandlers.logging.postMessage({
                    eventId: '手指滑动展示',
                    eventContent: {
                        param: '手指滑动第' + $liShowIndex + '张图片-' + $brand + '-' + $series
                    }
                });
            } else if (window.JavaBridge) {
                window.JavaBridge.callAppLogging('手指滑动展示', JSON.stringify({
                    'param': '手指滑动第' + $liShowIndex + '张图片-' + $brand + '-' + $series
                }));
            }

            // 修改图片索引
            var slideIndexPic = $liShowIndex === $li.length ? 0 : $liShowIndex;
            $('.js-slider-index').removeClass('active').eq(slideIndexPic).addClass('active');

            // 一段时间内不可重复滑动
            setTimeout(function () {
                IS_SWIPE = true;
                guideContent5.append($li0);
                $li.removeClass('activeRotateCardRight activeRotateCardLeft');
            }, 990);
        }
    };
    guideContent5.swipe(handler, {
        preventDefault: false
    });

    $('.js-guide-footer-btn').on('click', function () {
        var preferenceBrand = $(this).parents('li').data('brand');
        var preferenceSeries = $(this).parents('li').data('series');
        var preferenceShow = $(this).parents('li').data('show');
        var $profiles = {
            uuid: $uuid,
            brand_preference: preferenceBrand,
            series_preference: preferenceSeries
        };
        $.post(PROFILE_URL, $profiles, function () {}, 'json');

        if (navigator.userAgent.indexOf("iOS") > -1) {
            window.webkit.messageHandlers.logging.postMessage({
                eventId: '用户点击推荐车',
                eventContent: {
                    param: '第' + preferenceShow + '张图片-' + preferenceBrand + '-' + preferenceSeries
                }
            });
        } else if (window.JavaBridge) {
            window.JavaBridge.callAppLogging('用户点击推荐车', JSON.stringify({
                'param': '第' + preferenceShow + '张图片-' + preferenceBrand + '-' + preferenceSeries
            }));
        }
    });
};
var part4 = function part4(data) {
    currentPage(4);
    $('.js-page-num').hide();
    var $urlSearch = 'rrc://cars?ui_dismiss_webview=1';
    var $li = '';
    var $slideIndex = '';
    var $footerText = '';
    var $footerBtn = '';
    var mapTap = {
        space_tag: '空间大',
        power_tag: '动力足',
        fuel_tag: '低油耗',
        look_tag: '外观好看',
        interior_tag: '内饰讲究'
    };
    var priceMap = {
        '0-5': '5万以下',
        '5-10': '5到10万',
        '10-15': '10到15万',
        '15-20': '15到20万',
        '20-30': '20到30万',
        '30-1000': '30万以上'
    };
    var ageMap = {
        '0-3': '3年以内',
        '3-5': '3到5年',
        '5-12': '5到12年',
        '0-12': '12年以下'
    };
    var $profiles = {
        uuid: $uuid,
        age_preference: data.age
    };
    $.post(PROFILE_URL, $profiles, function () {}, 'json');
    // 发送请求数据 返回列表
    $.post(QUALITY_CAR_URL, data, function (jsons) {
        var status = parseInt(jsons.status, 10);
        setTimeout(function () {
            if (status !== 0) {
                window.location.href = $urlSearch;
            }
        }, 5000);
        if (status === 0) {
            var jsonDatas = jsons.data;
            jsonDatas.forEach(function (jsonData, index) {
                var $span = '';
                var $footerLink = '';
                var $tags = jsonData.tag;
                var $new_car_price = jsonData.newcar_price === null ? '暂无' : jsonData.newcar_price + '\u4E07';
                var $old_car_price = jsonData.deal_price === null ? '暂无' : jsonData.deal_price + '\u4E07';
                var $logName = jsonData.city + '-\uFF08' + jsonData.deal_price + '\uFF09-' + jsonData.brand + '-' + jsonData.series;

                var seachPrice = '' + jsonData.condition.price;
                var searchAge = '' + jsonData.condition.age;
                var searchBrand = '' + jsonData.brand;
                var searchSeries = '' + jsonData.condition.series;

                // 解决Android定位不准问题
                if (searchSeries.indexOf('(进口)') !== -1) {
                    if (navigator.userAgent.indexOf("Android") > -1) {
                        $footerLink = $urlSearch + '&price=' + seachPrice + '&price_desc=' + priceMap[seachPrice] + '&age=' + searchAge + '&age_desc=' + ageMap[searchAge] + '&wd=' + searchSeries + '&wd_desc=' + searchSeries; // eslint-disable-line
                    } else {
                        $footerLink = $urlSearch + '&price=' + seachPrice + '&age=' + searchAge + '&wd=' + searchSeries;
                    }
                } else if (navigator.userAgent.indexOf("Android") > -1) {
                    $footerLink = $urlSearch + '&price=' + seachPrice + '&price_desc=' + priceMap[seachPrice] + '&age=' + searchAge + '&age_desc=' + ageMap[searchAge] + '&brand=' + searchBrand + '&brand_desc=' + searchBrand + '&car_series=' + searchSeries + '&car_series_desc=' + searchSeries; // eslint-disable-line
                } else {
                    $footerLink = $urlSearch + '&price=' + seachPrice + '&age=' + searchAge + '&brand=' + searchBrand + '&car_series=' + searchSeries;
                }
                // 遍历标签
                $tags.forEach(function ($tag) {
                    $span += '<span>' + mapTap[$tag] + '</span>';
                });
                // 判断有无推荐车情况
                if (jsons.meta.is_online === 0) {
                    if (typeof $queryString.ui_subscribe === 'string') {
                        $footerLink += '&ui_subscribe=1';
                    }
                    $footerBtn = '去看看';
                    $footerText = jsonData.city + '\u5730\u533A \u5F53\u524D\u5171\u6709<span>' + jsonData.car_number + '\u8F86<span>' + jsonData.series;
                } else {
                    $footerBtn = '有新上通知我';
                    $footerLink += '&ui_subscribe=1';
                    $footerText = jsonData.city + '\u5730\u533A \u5F53\u524D\u65E0\u5728\u552E\u8F66';
                }
                // 添加数据
                $li += '<li class="tuijian js-tuijian" data-show="' + (index + 1) + '" data-series="' + jsonData.series + '" data-brand="' + jsonData.brand + '">\n                                <div class="guide-header">\n<div class="guide-headr-left">\n                                       <p>\u4E3A\u4F60\u627E\u5230' + jsons.meta.count + '\u6B3E\u5408\u9002\u7684\u8F66</p>\n                                    </div>\n                                    <div class="guide-header-right">\u63A8\u8350' + (index + 1) + '</div>\n                                </div>\n                                <div class="guide-car">\n                                    <div class="guide-car-img">\n                                        <img src=' + jsonData.img_url + '>\n                                    </div>\n                                    <div class="guide-car-name">' + jsonData.series + '</div>\n                                    <p class="guide-car-tag">' + $span + '</p>\n                                    <div class="guide-car-price">\n                                        <div class="old-price car-price">\n                                            <em>\u4E8C\u624B\u8F66\u6210\u4EA4\u4EF7</em>\n                                            <p>' + $old_car_price + '</p>\n                                        </div>\n                                        <div class="new-price car-price">\n                                            <em>\u65B0\u8F66\u4EF7</em>\n                                            <p>' + $new_car_price + '</p>\n                                        </div>\n                                    </div>\n                                </div>\n                                <div class="guide-footer">\n                                    <p class="guide-footer-text">' + $footerText + '</p>\n                                    <a class="guide-footer-btn js-guide-footer-btn" href=' + $footerLink + ' rrc-event-name="tuijian-car' + (index + 1) + '" rrc-event-param=' + $logName + '>' + $footerBtn + '</a>\n                                </div>\n                            </li>';
                // 添加索引
                if (index === 0) {
                    $slideIndex += '<span class="js-slider-index active"></span>';
                } else {
                    $slideIndex += '<span class="js-slider-index"></span>';
                }
            });
            $('.js-guide-5').append($li);
            $('.js-nav-slider').append($slideIndex);
            setTimeout(part5, 1000);
        }
    }, 'json');
};

var part3 = function part3(data) {
    currentPage(3);
    var $profiles = {
        uuid: $uuid,
        preference_describe: data.text
    };
    // 发送用户画像
    $.post(PROFILE_URL, $profiles, function () {}, 'json');
    $('.js-data-car-age').on('click', function () {
        var $age = $(this).data('age');
        if ($age !== '') {
            data.age = $age;
        }
        part4(data);
    });
};

var part2 = function part2(data) {
    var portrait_source = '';
    var $data = {
        price: data,
        city: $city
    };

    // 判断手机访问类型
    if (navigator.userAgent.indexOf("Android") > -1) {
        portrait_source = 'Android';
    } else if (navigator.userAgent.indexOf("iOS") > -1) {
        portrait_source = 'Ios';
    } else {
        portrait_source = 'Other';
    }

    var $profiles = {
        uuid: $uuid,
        budget: data,
        portrait_source: portrait_source
    };
    // 发送用户画像
    $.post(PROFILE_URL, $profiles, function () {}, 'json');
    currentPage(2);
    var ndFilter = $('.js-guide-ask li');
    var ndSubmitBtn = $('.js-guide-ask-btn');
    ndFilter.on('click', '.js-data-ask', function () {
        $(this).toggleClass('active');
        if (ndFilter.find('.active').length > 4) {
            $('.js-error-show').html('最多选择四项').fadeIn().fadeOut(2000);
            $(this).toggleClass('active');
        }
    });
    ndSubmitBtn.on('click', function () {
        var newStates = {
            tag: [],
            demand: [],
            text: []
        };
        if (ndFilter.find('.active').length === 0) {
            $('.js-error-show').html('最少选择一项').fadeIn().fadeOut(2000);
        } else {
            ndFilter.find('.active').each(function (index, item) {
                var $category = $(item).data('category');
                var $ask = $(item).data('ask');
                var $text = $(item).html();
                newStates.text.push($text);
                if ($category === 'demand') {
                    newStates.demand.push($ask);
                } else {
                    newStates.tag.push($ask);
                }
            });
            $data.text = newStates.text.join(',');
            $('.js-page2').html($data.text);
            if (newStates.demand.length > 0) {
                $data.demand = newStates.demand.join(',');
            }
            if (newStates.tag.length > 0) {
                $data.tag = newStates.tag.join(',');
            }
            if (navigator.userAgent.indexOf("iOS") > -1) {
                window.webkit.messageHandlers.logging.postMessage({
                    eventId: 'choose-car-type',
                    eventContent: {
                        param: $data.text ? $data.text : ""
                    }
                });
            } else if (window.JavaBridge) {
                window.JavaBridge.callAppLogging('choose-car-type', JSON.stringify({
                    'param': $data.text ? $data.text : ""
                }));
            }
            part3($data);
        }
    });
};

currentPage(1);
$('.js-data-price').on('click', function () {
    var $dataPrice = $(this).data('price');
    $('.js-page1').html($dataPrice + '\u4E07');
    part2($dataPrice);
});
